Set echo on;
Set autotrace on;
Set time on;
Set timing on;

ALTER SESSION set query_rewrite_integrity = TRUSTED;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	"D_CALENDAR"."CAL_DATE"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_CALENDAR" "D_CALENDAR"
WHERE
	"F_SALE"."SAL_DATE" = "D_CALENDAR"."CAL_DATE"
GROUP BY
	"D_CALENDAR"."CAL_DATE"
ORDER BY
	1
)
WHERE ROWNUM <= 10;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	"D_CALENDAR"."CAL_DATE"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_CALENDAR" "D_CALENDAR"
WHERE
	"F_SALE"."SAL_DATE" = "D_CALENDAR"."CAL_DATE"
GROUP BY
	"D_CALENDAR"."CAL_DATE"
ORDER BY
	1
)
WHERE ROWNUM <= 10;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	"D_CALENDAR"."CAL_YEARMONTH"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_CALENDAR" "D_CALENDAR"
WHERE
	"F_SALE"."SAL_DATE" = "D_CALENDAR"."CAL_DATE"
GROUP BY
	"D_CALENDAR"."CAL_YEARMONTH"
ORDER BY
	1
)
WHERE ROWNUM <= 10;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	"D_CALENDAR"."CAL_YEARMONTH"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_CALENDAR" "D_CALENDAR"
WHERE
	"F_SALE"."SAL_DATE" = "D_CALENDAR"."CAL_DATE"
GROUP BY
	"D_CALENDAR"."CAL_YEARMONTH"
ORDER BY
	1
)
WHERE ROWNUM <= 10;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	"D_CALENDAR"."CAL_YEAR"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_CALENDAR" "D_CALENDAR"
WHERE
	"F_SALE"."SAL_DATE" = "D_CALENDAR"."CAL_DATE"
GROUP BY
	"D_CALENDAR"."CAL_YEAR"
ORDER BY
	1
)
WHERE ROWNUM <= 10;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	"D_CALENDAR"."CAL_YEAR"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_CALENDAR" "D_CALENDAR"
WHERE
	"F_SALE"."SAL_DATE" = "D_CALENDAR"."CAL_DATE"
GROUP BY
	"D_CALENDAR"."CAL_YEAR"
ORDER BY
	1
)
WHERE ROWNUM <= 10;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	"D_VENDOR"."VDR_ID"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_VENDOR" "D_VENDOR"
WHERE
	"F_SALE"."SAL_VENDOR" = "D_VENDOR"."VDR_ID"
GROUP BY
	"D_VENDOR"."VDR_ID"
ORDER BY
	1
)
WHERE ROWNUM <= 10;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	"D_VENDOR"."VDR_ID"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_VENDOR" "D_VENDOR"
WHERE
	"F_SALE"."SAL_VENDOR" = "D_VENDOR"."VDR_ID"
GROUP BY
	"D_VENDOR"."VDR_ID"
ORDER BY
	1
)
WHERE ROWNUM <= 10;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	"D_AGENCY"."AGC_ID"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_VENDOR" "D_VENDOR"
	,"DEMO_USR"."D_AGENCY" "D_AGENCY"
WHERE
	"F_SALE"."SAL_VENDOR" = "D_VENDOR"."VDR_ID"
	AND "D_VENDOR"."VDR_AGENCY" = "D_AGENCY"."AGC_ID"
GROUP BY
	"D_AGENCY"."AGC_ID"
ORDER BY
	1
)
WHERE ROWNUM <= 10;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	"D_AGENCY"."AGC_ID"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_VENDOR" "D_VENDOR"
	,"DEMO_USR"."D_AGENCY" "D_AGENCY"
WHERE
	"F_SALE"."SAL_VENDOR" = "D_VENDOR"."VDR_ID"
	AND "D_VENDOR"."VDR_AGENCY" = "D_AGENCY"."AGC_ID"
GROUP BY
	"D_AGENCY"."AGC_ID"
ORDER BY
	1
)
WHERE ROWNUM <= 10;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	"D_REGION"."REG_ID"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_VENDOR" "D_VENDOR"
	,"DEMO_USR"."D_AGENCY" "D_AGENCY"
	,"DEMO_USR"."D_REGION" "D_REGION"
WHERE
	"F_SALE"."SAL_VENDOR" = "D_VENDOR"."VDR_ID"
	AND "D_VENDOR"."VDR_AGENCY" = "D_AGENCY"."AGC_ID"
	AND "D_AGENCY"."AGC_REGION" = "D_REGION"."REG_ID"
GROUP BY
	"D_REGION"."REG_ID"
ORDER BY
	1
)
WHERE ROWNUM <= 10;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	"D_REGION"."REG_ID"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_VENDOR" "D_VENDOR"
	,"DEMO_USR"."D_AGENCY" "D_AGENCY"
	,"DEMO_USR"."D_REGION" "D_REGION"
WHERE
	"F_SALE"."SAL_VENDOR" = "D_VENDOR"."VDR_ID"
	AND "D_VENDOR"."VDR_AGENCY" = "D_AGENCY"."AGC_ID"
	AND "D_AGENCY"."AGC_REGION" = "D_REGION"."REG_ID"
GROUP BY
	"D_REGION"."REG_ID"
ORDER BY
	1
)
WHERE ROWNUM <= 10;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	"D_COUNTRY"."CTR_ID"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_VENDOR" "D_VENDOR"
	,"DEMO_USR"."D_AGENCY" "D_AGENCY"
	,"DEMO_USR"."D_REGION" "D_REGION"
	,"DEMO_USR"."D_COUNTRY" "D_COUNTRY"
WHERE
	"F_SALE"."SAL_VENDOR" = "D_VENDOR"."VDR_ID"
	AND "D_VENDOR"."VDR_AGENCY" = "D_AGENCY"."AGC_ID"
	AND "D_AGENCY"."AGC_REGION" = "D_REGION"."REG_ID"
	AND "D_REGION"."REG_COUNTRY" = "D_COUNTRY"."CTR_ID"
GROUP BY
	"D_COUNTRY"."CTR_ID"
ORDER BY
	1
)
WHERE ROWNUM <= 10;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	"D_COUNTRY"."CTR_ID"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_VENDOR" "D_VENDOR"
	,"DEMO_USR"."D_AGENCY" "D_AGENCY"
	,"DEMO_USR"."D_REGION" "D_REGION"
	,"DEMO_USR"."D_COUNTRY" "D_COUNTRY"
WHERE
	"F_SALE"."SAL_VENDOR" = "D_VENDOR"."VDR_ID"
	AND "D_VENDOR"."VDR_AGENCY" = "D_AGENCY"."AGC_ID"
	AND "D_AGENCY"."AGC_REGION" = "D_REGION"."REG_ID"
	AND "D_REGION"."REG_COUNTRY" = "D_COUNTRY"."CTR_ID"
GROUP BY
	"D_COUNTRY"."CTR_ID"
ORDER BY
	1
)
WHERE ROWNUM <= 10;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	"D_COUNTRY"."CTR_NAME"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_VENDOR" "D_VENDOR"
	,"DEMO_USR"."D_AGENCY" "D_AGENCY"
	,"DEMO_USR"."D_REGION" "D_REGION"
	,"DEMO_USR"."D_COUNTRY" "D_COUNTRY"
WHERE
	"F_SALE"."SAL_VENDOR" = "D_VENDOR"."VDR_ID"
	AND "D_VENDOR"."VDR_AGENCY" = "D_AGENCY"."AGC_ID"
	AND "D_AGENCY"."AGC_REGION" = "D_REGION"."REG_ID"
	AND "D_REGION"."REG_COUNTRY" = "D_COUNTRY"."CTR_ID"
GROUP BY
	"D_COUNTRY"."CTR_NAME"
ORDER BY
	1
)
WHERE ROWNUM <= 10;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	"D_COUNTRY"."CTR_NAME"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_VENDOR" "D_VENDOR"
	,"DEMO_USR"."D_AGENCY" "D_AGENCY"
	,"DEMO_USR"."D_REGION" "D_REGION"
	,"DEMO_USR"."D_COUNTRY" "D_COUNTRY"
WHERE
	"F_SALE"."SAL_VENDOR" = "D_VENDOR"."VDR_ID"
	AND "D_VENDOR"."VDR_AGENCY" = "D_AGENCY"."AGC_ID"
	AND "D_AGENCY"."AGC_REGION" = "D_REGION"."REG_ID"
	AND "D_REGION"."REG_COUNTRY" = "D_COUNTRY"."CTR_ID"
GROUP BY
	"D_COUNTRY"."CTR_NAME"
ORDER BY
	1
)
WHERE ROWNUM <= 10;



alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	"D_CUSTOMER"."CUS_ID"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_CUSTOMER" "D_CUSTOMER"
WHERE
	"F_SALE"."SAL_CUSTOMER" = "D_CUSTOMER"."CUS_ID"
GROUP BY
	"D_CUSTOMER"."CUS_ID"
ORDER BY
	1
)
WHERE ROWNUM <= 10;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	"D_CUSTOMER"."CUS_ID"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_CUSTOMER" "D_CUSTOMER"
WHERE
	"F_SALE"."SAL_CUSTOMER" = "D_CUSTOMER"."CUS_ID"
GROUP BY
	"D_CUSTOMER"."CUS_ID"
ORDER BY
	1
)
WHERE ROWNUM <= 10;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

SELECT
	"D_CALENDAR"."CAL_YEAR"
	,"D_CUSTOMER_SUB_GROUP"."CSB_DESC"
	,"D_COUNTRY"."CTR_NAME"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_CUSTOMER" "D_CUSTOMER"
	,"DEMO_USR"."D_CUSTOMER_SUB_GROUP" "D_CUSTOMER_SUB_GROUP"
	,"DEMO_USR"."D_VENDOR" "D_VENDOR"
	,"DEMO_USR"."D_AGENCY" "D_AGENCY"
	,"DEMO_USR"."D_REGION" "D_REGION"
	,"DEMO_USR"."D_COUNTRY" "D_COUNTRY"
	,"DEMO_USR"."D_CALENDAR" "D_CALENDAR"
WHERE
	"F_SALE"."SAL_DATE" = "D_CALENDAR"."CAL_DATE"
	AND "F_SALE"."SAL_CUSTOMER" = "D_CUSTOMER"."CUS_ID"
	AND "D_CUSTOMER"."CUS_SUB_GROUP" = "D_CUSTOMER_SUB_GROUP"."CSB_ID"
	AND "D_REGION"."REG_COUNTRY" = "D_COUNTRY"."CTR_ID"
	AND "F_SALE"."SAL_VENDOR" = "D_VENDOR"."VDR_ID"
	AND "D_VENDOR"."VDR_AGENCY" = "D_AGENCY"."AGC_ID"
	AND "D_AGENCY"."AGC_REGION" = "D_REGION"."REG_ID"
	AND "D_REGION"."REG_COUNTRY" = "D_COUNTRY"."CTR_ID"
GROUP BY
	"D_CALENDAR"."CAL_YEAR"
	,"D_CUSTOMER_SUB_GROUP"."CSB_DESC"
	,"D_COUNTRY"."CTR_NAME"
ORDER BY
	1,2;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

SELECT
	"D_CALENDAR"."CAL_YEAR"
	,"D_CUSTOMER_SUB_GROUP"."CSB_DESC"
	,"D_COUNTRY"."CTR_NAME"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_CUSTOMER" "D_CUSTOMER"
	,"DEMO_USR"."D_CUSTOMER_SUB_GROUP" "D_CUSTOMER_SUB_GROUP"
	,"DEMO_USR"."D_VENDOR" "D_VENDOR"
	,"DEMO_USR"."D_AGENCY" "D_AGENCY"
	,"DEMO_USR"."D_REGION" "D_REGION"
	,"DEMO_USR"."D_COUNTRY" "D_COUNTRY"
	,"DEMO_USR"."D_CALENDAR" "D_CALENDAR"
WHERE
	"F_SALE"."SAL_DATE" = "D_CALENDAR"."CAL_DATE"
	AND "F_SALE"."SAL_CUSTOMER" = "D_CUSTOMER"."CUS_ID"
	AND "D_CUSTOMER"."CUS_SUB_GROUP" = "D_CUSTOMER_SUB_GROUP"."CSB_ID"
	AND "D_REGION"."REG_COUNTRY" = "D_COUNTRY"."CTR_ID"
	AND "F_SALE"."SAL_VENDOR" = "D_VENDOR"."VDR_ID"
	AND "D_VENDOR"."VDR_AGENCY" = "D_AGENCY"."AGC_ID"
	AND "D_AGENCY"."AGC_REGION" = "D_REGION"."REG_ID"
	AND "D_REGION"."REG_COUNTRY" = "D_COUNTRY"."CTR_ID"
GROUP BY
	"D_CALENDAR"."CAL_YEAR"
	,"D_CUSTOMER_SUB_GROUP"."CSB_DESC"
	,"D_COUNTRY"."CTR_NAME"
ORDER BY
	1,2;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

SELECT
	"D_CALENDAR"."CAL_YEAR"
	,"D_CUSTOMER_GROUP"."CGR_DESC"
	,"D_COUNTRY"."CTR_NAME"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_CUSTOMER" "D_CUSTOMER"
	,"DEMO_USR"."D_CUSTOMER_SUB_GROUP" "D_CUSTOMER_SUB_GROUP"
	,"DEMO_USR"."D_CUSTOMER_GROUP" "D_CUSTOMER_GROUP"
	,"DEMO_USR"."D_VENDOR" "D_VENDOR"
	,"DEMO_USR"."D_AGENCY" "D_AGENCY"
	,"DEMO_USR"."D_REGION" "D_REGION"
	,"DEMO_USR"."D_COUNTRY" "D_COUNTRY"
	,"DEMO_USR"."D_CALENDAR" "D_CALENDAR"
WHERE
	"F_SALE"."SAL_DATE" = "D_CALENDAR"."CAL_DATE"
	AND "F_SALE"."SAL_CUSTOMER" = "D_CUSTOMER"."CUS_ID"
	AND "D_CUSTOMER"."CUS_SUB_GROUP" = "D_CUSTOMER_SUB_GROUP"."CSB_ID"
	AND "D_CUSTOMER_SUB_GROUP"."CSB_GROUP" = "D_CUSTOMER_GROUP"."CGR_ID"
	AND "D_REGION"."REG_COUNTRY" = "D_COUNTRY"."CTR_ID"
	AND "F_SALE"."SAL_VENDOR" = "D_VENDOR"."VDR_ID"
	AND "D_VENDOR"."VDR_AGENCY" = "D_AGENCY"."AGC_ID"
	AND "D_AGENCY"."AGC_REGION" = "D_REGION"."REG_ID"
	AND "D_REGION"."REG_COUNTRY" = "D_COUNTRY"."CTR_ID"
GROUP BY
	"D_CALENDAR"."CAL_YEAR"
	,"D_CUSTOMER_GROUP"."CGR_DESC"
	,"D_COUNTRY"."CTR_NAME"
ORDER BY
	1,2;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

SELECT
	"D_CALENDAR"."CAL_YEAR"
	,"D_CUSTOMER_GROUP"."CGR_DESC"
	,"D_COUNTRY"."CTR_NAME"
	,COUNT(*)
	,sum(SAL_AMOUNT)
	,sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE" "F_SALE"
	,"DEMO_USR"."D_CUSTOMER" "D_CUSTOMER"
	,"DEMO_USR"."D_CUSTOMER_SUB_GROUP" "D_CUSTOMER_SUB_GROUP"
	,"DEMO_USR"."D_CUSTOMER_GROUP" "D_CUSTOMER_GROUP"
	,"DEMO_USR"."D_VENDOR" "D_VENDOR"
	,"DEMO_USR"."D_AGENCY" "D_AGENCY"
	,"DEMO_USR"."D_REGION" "D_REGION"
	,"DEMO_USR"."D_COUNTRY" "D_COUNTRY"
	,"DEMO_USR"."D_CALENDAR" "D_CALENDAR"
WHERE
	"F_SALE"."SAL_DATE" = "D_CALENDAR"."CAL_DATE"
	AND "F_SALE"."SAL_CUSTOMER" = "D_CUSTOMER"."CUS_ID"
	AND "D_CUSTOMER"."CUS_SUB_GROUP" = "D_CUSTOMER_SUB_GROUP"."CSB_ID"
	AND "D_CUSTOMER_SUB_GROUP"."CSB_GROUP" = "D_CUSTOMER_GROUP"."CGR_ID"
	AND "D_REGION"."REG_COUNTRY" = "D_COUNTRY"."CTR_ID"
	AND "F_SALE"."SAL_VENDOR" = "D_VENDOR"."VDR_ID"
	AND "D_VENDOR"."VDR_AGENCY" = "D_AGENCY"."AGC_ID"
	AND "D_AGENCY"."AGC_REGION" = "D_REGION"."REG_ID"
	AND "D_REGION"."REG_COUNTRY" = "D_COUNTRY"."CTR_ID"
GROUP BY
	"D_CALENDAR"."CAL_YEAR"
	,"D_CUSTOMER_GROUP"."CGR_DESC"
	,"D_COUNTRY"."CTR_NAME"
ORDER BY
	1,2;
