SET ECHO ON;
SET TIME ON;
SET TIMING ON;

DROP USER DEMO_USR CASCADE;

CREATE USER DEMO_USR IDENTIFIED BY DEMO_USR;


-- To open session and activate / deactivate parameters
GRANT CREATE SESSION TO DEMO_USR;
GRANT ALTER SESSION TO DEMO_USR;

-- To create our model
GRANT CREATE TABLE TO DEMO_USR;
ALTER USER DEMO_USR QUOTA UNLIMITED ON USERS;

-- Not mandatory for the demo but useful for some hints and troubleshooting
GRANT CREATE PROCEDURE TO DEMO_USR;
GRANT CREATE TRIGGER TO DEMO_USR;