Set echo on;
Set autotrace on;
Set time on;
Set timing on;

ALTER SESSION set query_rewrite_integrity = TRUSTED;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_DATE,
	SAL_PRODUCT,
	SAL_VENDOR,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_PRODUCT,
	SAL_VENDOR,
	SAL_CUSTOMER
ORDER BY
	1, 2, 3, 4
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_DATE,
	SAL_PRODUCT,
	SAL_VENDOR,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_PRODUCT,
	SAL_VENDOR,
	SAL_CUSTOMER
ORDER BY
	1, 2, 3, 4
)
WHERE ROWNUM <= 1;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_DATE,
	SAL_PRODUCT,
	SAL_VENDOR,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_PRODUCT,
	SAL_VENDOR
ORDER BY
	1, 2, 3
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_DATE,
	SAL_PRODUCT,
	SAL_VENDOR,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_PRODUCT,
	SAL_VENDOR
ORDER BY
	1, 2, 3
)
WHERE ROWNUM <= 1;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_DATE,
	SAL_PRODUCT,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_PRODUCT,
	SAL_CUSTOMER
ORDER BY
	1, 2, 3
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_DATE,
	SAL_PRODUCT,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_PRODUCT,
	SAL_CUSTOMER
ORDER BY
	1, 2, 3
)
WHERE ROWNUM <= 1;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_DATE,
	SAL_VENDOR,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_VENDOR,
	SAL_CUSTOMER
ORDER BY
	1, 2, 3
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_DATE,
	SAL_VENDOR,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_VENDOR,
	SAL_CUSTOMER
ORDER BY
	1, 2, 3
)
WHERE ROWNUM <= 1;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_PRODUCT,
	SAL_VENDOR,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_PRODUCT,
	SAL_VENDOR,
	SAL_CUSTOMER
ORDER BY
	1, 2, 3
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_PRODUCT,
	SAL_VENDOR,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_PRODUCT,
	SAL_VENDOR,
	SAL_CUSTOMER
ORDER BY
	1, 2, 3
)
WHERE ROWNUM <= 1;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_DATE,
	SAL_PRODUCT,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_PRODUCT
ORDER BY
	1, 2
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_DATE,
	SAL_PRODUCT,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_PRODUCT
ORDER BY
	1, 2
)
WHERE ROWNUM <= 1;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_DATE,
	SAL_VENDOR,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_VENDOR
ORDER BY
	1, 2
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_DATE,
	SAL_VENDOR,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_VENDOR
ORDER BY
	1, 2
)
WHERE ROWNUM <= 1;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_PRODUCT,
	SAL_VENDOR,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_PRODUCT,
	SAL_VENDOR
ORDER BY
	1, 2
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_PRODUCT,
	SAL_VENDOR,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_PRODUCT,
	SAL_VENDOR
ORDER BY
	1, 2
)
WHERE ROWNUM <= 1;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_DATE,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_CUSTOMER
ORDER BY
	1, 2
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_DATE,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_CUSTOMER
ORDER BY
	1, 2
)
WHERE ROWNUM <= 1;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_PRODUCT,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_PRODUCT,
	SAL_CUSTOMER
ORDER BY
	1, 2
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_PRODUCT,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_PRODUCT,
	SAL_CUSTOMER
ORDER BY
	1, 2
)
WHERE ROWNUM <= 1;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_VENDOR,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_VENDOR,
	SAL_CUSTOMER
ORDER BY
	1, 2
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_VENDOR,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_VENDOR,
	SAL_CUSTOMER
ORDER BY
	1, 2
)
WHERE ROWNUM <= 1;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_DATE,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE
ORDER BY
	1
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_DATE,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE
ORDER BY
	1
)
WHERE ROWNUM <= 1;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_PRODUCT,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_PRODUCT
ORDER BY
	1
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_PRODUCT,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_PRODUCT
ORDER BY
	1
)
WHERE ROWNUM <= 1;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_VENDOR,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_VENDOR
ORDER BY
	1
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_VENDOR,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_VENDOR
ORDER BY
	1
)
WHERE ROWNUM <= 1;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_CUSTOMER
ORDER BY
	1
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_CUSTOMER
ORDER BY
	1
)
WHERE ROWNUM <= 1;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
)
WHERE ROWNUM <= 1;

ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
)
WHERE ROWNUM <= 1;
